<?PHP
// vim: set expandtab tabstop=4 shiftwidth=4:
// +----------------------------------------------------------------------+
// | SAPID: XML Sapiens Engine Demonstrator                               |
// +----------------------------------------------------------------------+
// | Author:  Max Baryshnikov aka Mephius <mb@rg.by>	                  |
// | Copyright (c) 2004 Max Baryshnikov                                   |
// | http://sapid.sourceforge.net	                                      |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+
// Release: 08.09.04 (dd/mm/yy)
// $Id: debug.inc.php,v 1.1 2005/06/10 15:30:04 mephius Exp $

/**
* @return void
* @param array $code
* @desc Debug function
*/
define ("FATAL", E_USER_ERROR); 
define ("ERROR", E_USER_WARNING); 
define ("WARNING", E_USER_NOTICE); 

function ErrorHandler($errno, $errstr, $errfile, $errline) {
	
	global $env;
	$error = "";
	
	   $errortype = array ( 
               1   =>  "Error", 
               2   =>  "Warning", 
               4   =>  "Parsing Error", 
               8   =>  "Notice", 
               16  =>  "Core Error", 
               32  =>  "Core Warning", 
               64  =>  "Compile Error", 
               128 =>  "Compile Warning", 
               256 =>  "User Error", 
               512 =>  "User Warning", 
               1024=>  "User Notice" 
               );  

               //if($errno!=8) d("$errno, $errstr, $errfile, $errline");
               if( preg_match("/Failed\sopening/is", $errstr)) $errno=1;
               
	switch ($errno) {
		case 1:
		case 4:
		case 16:
		case 32:
		case 64:
		case 256: 
		$error = "<b>FATAL</b> [$errno] $errstr<br />\n";
		$error .= "  Fatal error in line $errline of file $errfile";
		$error .= ", PHP " . PHP_VERSION . " (" . PHP_OS . ")<br />\n";
		$error .= "Aborting...<br />\n";
		message_die($error, $errortype[$errno]);
		break;
		case 2:
		case WARNING:
		if(DEBUG>0) $env["error"] = "<b>WARNING</b> [$errno] $errstr error <br />in line $errline of file $errfile<br />\n";
		break;
		case E_NOTICE:
		break;
		default:
		if(DEBUG>0) $env["error"] = "Unkown error type: [$errno] $errstr - $errfile:$errline<br />\n";
		break;
	}
}

Error_Reporting(1+2+4); 
set_error_handler("ErrorHandler");

function d($var=false)
{
	ob_end_clean();
	echo '<pre style="font-size: 10px;  color: Maroon; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">';
	print_r($var);
	echo '</pre>';
}


/**
* @return void
* @desc Page timeloading monitor
*/
function getmicrotime()
{
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);
}


$env["time_start"]=getmicrotime();

?>