<?PHP
// vim: set expandtab tabstop=4 shiftwidth=4:
// +----------------------------------------------------------------------+
// | SAPID: XML Sapiens Engine Demonstrator                               |
// +----------------------------------------------------------------------+
// | Author:  Dmitry Sheiko <sheiko@cmsdevelopment.com>	                  |
// | Copyright (c) 2005 Dmitry Sheiko	                                  |
// | http://sapid.sourceforge.net	                                      |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+
// Release: 11.07.05 (dd/mm/yy)
// $Id: db.lib.php,v 1.2 2005/06/14 14:23:48 mephius Exp $

/*
 Using samples:
 
 1) $fetch = $this->row_fetch_array($sql); 
 2) $r=$this->sql_query($sql);
		while($fetch = $this->sql_fetchrow($r))	{ } 
		$this->sql_freeresult($r); 
 3) $r=$this->sql_query($sql); $len = $this->sql_numrows($r);
 
*/


class dbapi extends sql_db {

	var $db_prefix = "";
	var $limit_start = 0;
	var $limit_finish = 0;
	var $where = "";
	var $allchannels = false;
	var $length = 0;
	var $order = false;
	var $range = false;
	
	function dbapi($sqlserver, $sqluser, $sqlpassword, $database, $dbprefix, $persistency = true) {
		$this->db_prefix = $dbprefix;
		return $this->sql_db($sqlserver, $sqluser, $sqlpassword, $database, $persistency);
	}
	
	function row_fetch_array($query) { 
		$r=$this->sql_query($query);
		$result=$this->sql_fetchrow($r);
		$this->sql_freeresult($r);
		/* Strip Slashes */
		if( get_magic_quotes_gpc() ) {
			if($result) {foreach($result as $key=>$val){
				if(is_int($key)) unset($result[$key]);
					else $result[$key]=stripslashes($result[$key]);}
			}
		}
		return $result;
	} 	
		
	
	function get_sql($sql) {
		$objdata = array();
		$fetch = array();
		$f = array();
		$r = false;
		$r1 = false;

		if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
		while($fetch = $this->sql_fetchrow($r))	{ 
			if($fetch ) {
				$sql = "SELECT B.var, B.data FROM ".$this->db_prefix."data B WHERE B.parent_id = ".$fetch["id"];
				if(!$r1=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
				while($f = $this->sql_fetchrow($r1))	{ 
					if(get_magic_quotes_gpc()) $fetch["data"]=stripslashes($fetch["data"]);
					$objdata[ $fetch["id"] ][strtoupper($f["var"])] = $objdata[ $fetch["id"] ][strtolower($f["var"])] = $f["data"];
				}
				$this->sql_freeresult($r1); 
				$objdata[ $fetch["id"] ]["cdate"] = $fetch["cdate"];
				$objdata[ $fetch["id"] ]["mdate"] = $fetch["mdate"];
				$objdata[ $fetch["id"] ]["ip"] = $fetch["ip"];
				$objdata[ $fetch["id"] ]["parent_id"] = $fetch["parent_id"];
				$objdata[ $fetch["id"] ]["ID"] = $objdata[ $fetch["id"] ]["id"] = $fetch["id"];
			}
		} 
		$this->sql_freeresult($r); 
		
		return $objdata;				
	}
	
	/**
	* @return array
	* @param string $filename
	* @desc get data from xml file
	*/
	function get_data($parent_id=false, $id = false){
		global $sapi_obj;

		$objdata = array();
		$limit = "";
		$sql = "";
		$fetch = array();
		$f = array();
		$r = false;
		$r1 = false;
		$order = " ORDER by A.cdate DESC";
		
		
		if($this->order=="datecasc") $order = " ORDER by A.cdate ASC";
		if($this->order=="datecdesc") $order = " ORDER by A.cdate DESC";
		
		if($this->order=="index_asc" AND $sapi_obj->env["index"]) { $order = " ORDER by B.data ASC"; $this->where = " AND B.var='".$sapi_obj->env["index"]."' "; }
		if($this->order=="index_desc" AND $sapi_obj->env["index"]) { $order = " ORDER by B.data DESC"; $this->where = " AND B.var='".$sapi_obj->env["index"]."' "; }
		
		if($this->limit_finish) $limit = " LIMIT ".(int)$this->limit_start.", ".($this->limit_finish-$this->limit_start+1);
		
		if($this->range!="anywhere")
		$where_channel = "AND A.parent_id=".$parent_id."";
		
		if($this->allchannels) $where_channel = "";
		
		// Number of rows
		if($id) 
			$this->length = 1;
		else {
			$sql = "SELECT A.id, UNIX_TIMESTAMP(A.cdate) as cdate,  UNIX_TIMESTAMP(A.mdate) as mdate, A.ip, 
			B.var, B.data FROM ".$this->db_prefix."tree A, ".$this->db_prefix."data B WHERE A.id=B.parent_id $where_channel ".$this->where." GROUP by A.id";
			$r=$this->sql_query($sql);
			$this->length = (int)$this->sql_numrows($r);
			$this->sql_freeresult($r); 
		}
		
		// Get data
		if($id) 
			$sql = "SELECT A.id, A.parent_id, UNIX_TIMESTAMP(A.cdate) as cdate,  UNIX_TIMESTAMP(A.mdate) as mdate, A.ip, 
			B.var, B.data FROM ".$this->db_prefix."tree A, ".$this->db_prefix."data B WHERE A.id=B.parent_id AND A.id=".$id;
		else 		
			$sql = "SELECT A.id, A.parent_id, UNIX_TIMESTAMP(A.cdate) as cdate,  UNIX_TIMESTAMP(A.mdate) as mdate, A.ip FROM ".$this->db_prefix."tree A, ".$this->db_prefix."data B WHERE A.id=B.parent_id $where_channel ".$this->where." GROUP by A.id ".$order.$limit;

			
		if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
		$this->where = "";
		while($fetch = $this->sql_fetchrow($r))	{ 

			if( $fetch ) {
				$sql = "SELECT B.var, B.data FROM ".$this->db_prefix."data B WHERE B.parent_id = ".$fetch["id"];
				$r1=$this->sql_query($sql);
				while($f = $this->sql_fetchrow($r1))	{ 
					if(get_magic_quotes_gpc()) $fetch["data"]=stripslashes($fetch["data"]);
					$objdata[ $fetch["id"] ][strtoupper($f["var"])] = $objdata[ $fetch["id"] ][strtolower($f["var"])] = $f["data"];
				}
				$this->sql_freeresult($r1); 
				$objdata[ $fetch["id"] ]["cdate"] = $fetch["cdate"];
				$objdata[ $fetch["id"] ]["mdate"] = $fetch["mdate"];
				$objdata[ $fetch["id"] ]["ip"] = $fetch["ip"];
				$objdata[ $fetch["id"] ]["ID"] = $objdata[ $fetch["id"] ]["id"] = $fetch["id"];
				$objdata[ $fetch["id"] ]["parent_id"] = $fetch["parent_id"];
			}
		} 
		$this->sql_freeresult($r); 
		return $objdata;
	}
	
	
		function get_qcdata($id = false, $qc=false){
		global $sapi_obj;
		$sql = "";
		$fetch = array();
		$f = array();
		$r = false;
		$sql = "SELECT A.data FROM ".$this->db_prefix."data A WHERE A.parent_id=".$id." AND A.var='".$qc."' LIMIT 0,1";
		$fetch = $this->row_fetch_array($sql);
		return $fetch["data"];		
		
		}
	
	function get_navindexes($parent_id, $id, $ORDER){
		global $sapi_obj;
		
		$objdata = array();
		$sql = "";
		$fetch = array();
		$prev_id = false;
		$next_id = false;
		
		$order = " ORDER by A.cdate ";
		
		// Current 
		$sql = "SELECT A.cdate FROM ".$this->db_prefix."tree A WHERE A.parent_id=".$parent_id." AND A.id=".$id." LIMIT 0,1";
		$cdate = $this->row_fetch_array($sql);
		
		// Previous
		$sql = "SELECT A.id FROM ".$this->db_prefix."tree A WHERE A.parent_id=".$parent_id." AND A.cdate>'".$cdate["cdate"]."' $order ASC LIMIT 0,1";
		$fetch = $this->row_fetch_array($sql);
		$prev_id = $fetch["id"];
		
			
		// Next
		$sql = "SELECT A.id FROM ".$this->db_prefix."tree A WHERE A.parent_id=".$parent_id." AND A.cdate<'".$cdate["cdate"]."' $order DESC LIMIT 0,1";
		$fetch = $this->row_fetch_array($sql);
		$next_id = $fetch["id"];
		
		return array($prev_id, $next_id);
	}	
	
/*
	Appropriate values of $data["post_action"]
	ADDNEWIPROW
	ADDROW
	CHANGEROW
	UPDATEROW
	Source array $data["ROW"][..]
*/

	function save_data_row($parent_id=false, $data=false, $unique_ip=false){


		// Init
		$IP = getenv("REMOTE_ADDR");
		$DATE_CREATE = date("Y-m-d H:i:s");
		$r = false;
		$flag_ip_false = false;
		$sql = "";
		$fetch = array();
		$index = "";
		$val = "";
		$lastid = 0;
		
		if (!$data) $data=$_POST;
		if($data["ROW"]) $data["row"] = $data["ROW"];
		if($data["row"]) {
			
			if(!$data["row"]["IP"]) $data["row"]["IP"] = $IP; else $IP = $data["row"]["IP"];
			if(!$data["row"]["DATE_CREATE"]) $data["row"]["DATE_CREATE"] = $DATE_CREATE; else $DATE_CREATE = $data["row"]["DATE_CREATE"];
			
			$sql = "SELECT id FROM ".$this->db_prefix."tree WHERE ip='".$IP."'";
			$r=$this->sql_query($sql); 
			$flag_ip_false = $this->sql_numrows($r);
			$this->sql_freeresult($r); 

			
			if((!$flag_ip_false AND $data["post_action"]=="ADDNEWIPROW" ) OR $data["post_action"] =="ADDROW" ) {
				// Adding new row
				
				$sql = "INSERT INTO `".$this->db_prefix."tree` ( `id` , `sort_id` , `parent_id` , `cdate` , `mdate` , `ip` ) 
				VALUES ('', '1', '$parent_id', '".date("Y-m-d H:i:s")."', '".date("Y-m-d H:i:s")."', '".$IP."')";
				if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
				$this->sql_freeresult($r);
				
				$r=$this->sql_query("SELECT max(id) FROM ".$this->db_prefix."tree"); 
				$fetch=$this->sql_fetchrow($r); $lastid = $fetch['max(id)'];  
				$this->sql_freeresult($r); 
				$r=$this->sql_query("UPDATE ".$this->db_prefix."tree SET sort_id=".$lastid." WHERE id=".$lastid); 
				$this->sql_freeresult($r); 
				foreach($data["row"] as $index=>$val) {
					if( !get_magic_quotes_gpc() ) {	$val = addslashes($val); }
					if($index!="IP" AND $index!="DATE_CREATE" AND $index!="id" AND $index!="ID"  AND $index!="cdate") {
						$sql = "INSERT INTO `".$this->db_prefix."data` ( `id` , `parent_id` , `var` , `data` ) 
						VALUES ('', '$lastid', '$index', '$val')";
						$r=$this->sql_query($sql); 
						$this->sql_freeresult($r); 						
					}
				}
		
		
			}

			if( $data["post_action"] == "CHANGEROW" OR $data["post_action"] == "UPDATEROW") {
				$sql = "UPDATE ".$this->db_prefix."tree SET mdate='".date("Y-m-d H:i:s")."' WHERE id=".$data["row"]["id"];
				if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
				$this->sql_freeresult($r); 
				$sql = "DELETE FROM ".$this->db_prefix."data WHERE parent_id=".$data["row"]["id"];
				$r=$this->sql_query($sql); 
				$this->sql_freeresult($r); 
				
				foreach($data["row"] as $index=>$val) {
					if( !get_magic_quotes_gpc() ) {	$val = addslashes($val); }
					if($index!="IP" AND $index!="DATE_CREATE" AND $index!="id" AND $index!="ID"  AND $index!="cdate")
						$sql = "INSERT INTO `".$this->db_prefix."data` ( `id` , `parent_id` , `var` , `data` ) 
						VALUES ('', '".$data["row"]["id"]."', '$index', '$val')";
						$r=$this->sql_query($sql); 
						$this->sql_freeresult($r); 						
				}				
					
			}
			
		}
		return $lastid;
	}	
	
	

	function delete_data_row($arg_value, $arg_key="DATE_CREATE"){
		
		$r = false;
		$sql = "";
		$fetch = array();
		$index = "";
		$val = "";
		$id = 0;

		if($arg_key=="DATE_CREATE" or $arg_key=="cdate") {
		$sql = "SELECT id FROM ".$this->db_prefix."tree WHERE cdate='".$arg_value."'";
		$fetch = $this->row_fetch_array($sql); 
		$id = $fetch["id"];
		} elseif($arg_key=="mdate") {
		$sql = "SELECT id FROM ".$this->db_prefix."tree WHERE mdate='".$arg_value."'";
		$fetch = $this->row_fetch_array($sql); 
		$id = $fetch["id"];
		} elseif($arg_key=="id") {
			$id = $arg_value;
		} else { 		
		$sql = "SELECT parent_id FROM ".$this->db_prefix."data WHERE var='".$arg_key."' AND `data`='".$arg_value."'";
		$fetch = $this->row_fetch_array($sql); 
		$id = $fetch["parent_id"];
		}
		$sql = "DELETE FROM ".$this->db_prefix."data WHERE parent_id=".$id;
		$r=$this->sql_query($sql); 		
		$this->sql_freeresult($r); 
		
		$sql = "DELETE FROM ".$this->db_prefix."tree WHERE id=".$id;
		if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
		$this->sql_freeresult($r); 
	
		return true;
	}

	function change_data_row($date_create, $new_row){
		
		if(!$new_row) return false;
		
		$sql = "SELECT id FROM ".$this->db_prefix."tree WHERE cdate='".$date_create."'";
		$fetch = $this->row_fetch_array($sql); 
		$id = $fetch["id"];		
		
				$sql = "UPDATE ".$this->db_prefix."tree SET mdate='".date("Y-m-d H:i:s")."' WHERE id=".$id;
				if(!$r=$this->sql_query($sql)) { $error = $this->sql_error($r); message_die("<div style=\"background-color: white; padding: 5px; margin: 5px 0px 5px 0px; color: black;\">".($sql)."</div><b>SQL Error:</b> ".$error["message"]); }
				$this->sql_freeresult($r); 
				$sql = "DELETE FROM ".$this->db_prefix."data WHERE parent_id=".$id;
				$r=$this->sql_query($sql); 
				$this->sql_freeresult($r); 
				
				foreach($new_row as $index=>$val) {
					if( !get_magic_quotes_gpc() ) {	$val = addslashes($val); }
					if($index!="IP" AND $index!="DATE_CREATE" AND $index!="id"  AND $index!="cdate")
						$sql = "INSERT INTO `".$this->db_prefix."data` ( `id` , `parent_id` , `var` , `data` ) 
						VALUES ('', '$id', '$index', '$val')";
						$r=$this->sql_query($sql); 
						$this->sql_freeresult($r); 						
				}				
					
		
		return true;
	}	
		
}
?>